module tetrahedron(r,br) {
// corners at (+-1,0,-1/sqrt(2)) (0,+-1,1/sqrt2)
r2 = r/sqrt(2);
nf=18;
union() {
   hull() { translate([ r, 0,-r2]) sphere(br,$fn=nf);
            translate([-r, 0,-r2]) sphere(br,$fn=nf); }
   hull() { translate([ r, 0,-r2]) sphere(br,$fn=nf);
            translate([ 0,-r, r2]) sphere(br,$fn=nf); }
   hull() { translate([ r, 0,-r2]) sphere(br,$fn=nf);
            translate([ 0, r, r2]) sphere(br,$fn=nf); }
   hull() { translate([-r, 0,-r2]) sphere(br,$fn=nf);
            translate([ 0, r, r2]) sphere(br,$fn=nf); }
   hull() { translate([-r, 0,-r2]) sphere(br,$fn=nf);
            translate([ 0,-r, r2]) sphere(br,$fn=nf); }
   hull() { translate([ 0, r, r2]) sphere(br,$fn=nf);
            translate([ 0,-r, r2]) sphere(br,$fn=nf); }
}}

union() {
translate([0,0,11]) { rotate([90-acos(1/3)/2,0,0]) {
tetrahedron(20,2);
difference() { sphere(r=11,$fn=48);
               sphere(r=9 ,$fn=12);
      rotate([0,90-acos(1/3)/2,0]) cylinder(h=23,r=.8,$fn=6,center=true);
      rotate([90-acos(1/3)/2,0,0]) cylinder(h=23,r=.8,$fn=6,center=true);
      rotate([0,90+acos(1/3)/2,0]) cylinder(h=23,r=.8,$fn=6,center=true);
      rotate([90+acos(1/3)/2,0,0]) cylinder(h=23,r=.8,$fn=6,center=true);
   }}
}

translate([ 3*sqrt(2),3,0]) cylinder(h=2,r=.6,$fn=6);
translate([-3*sqrt(2),3,0]) cylinder(h=2,r=.6,$fn=6);
translate([0,-3*sqrt(3)  ,0]) cylinder(h=2,r=.6,$fn=6);

translate([0, 4*sqrt(3) ,0]) cylinder(h=3,r=.6,$fn=6);
translate([-4*sqrt(2),-4,0]) cylinder(h=3,r=.6,$fn=6);
translate([ 4*sqrt(2),-4,0]) cylinder(h=3,r=.6,$fn=6);

for (a=[0,60,120,180,240,300]) {
   translate([8*cos(a),8*sin(a),0]) cylinder(h=4.2,r=.6,$fn=6); }
for (a=[30,150,270]) {
   translate([10*cos(a),10*sin(a),0]) cylinder(h=9,r=.6,$fn=6); }
}